
package org.nzdl.service;

import java.util.*;

public class NzdlResultSet extends java.lang.Object {

  private List m_resultSet   = null;
  private int m_numDocs     = -1;
  private int m_resultType  = -1;
  private List m_queryTerms  = null;
  private List m_docIDs = null;
  /** the key is the query term, the value its frequency */
  private Map m_frequencies = null;
  /** 
   * the key is the docID, the value is the doc corresponding 
   * meta data which is also a Map where the key is the meta tag
   * and the value is a set of values for that tag
   */
  private Map m_docToMetaDataMap = null;

  /** */
  
  public NzdlResultSet() {
    m_resultSet = new ArrayList();
    m_docToMetaDataMap = new HashMap();
    m_docIDs = new ArrayList();
  }

  /** */

  public void add( NzdlQueryHit _hit ) {
    m_resultSet.add( _hit ) ;
    String id = _hit.getDocumentID();
    m_docIDs.add( id );
    m_docToMetaDataMap.put( id, _hit.getMetaData() );
  }

  public void setNumOfDocs( int _num ) {
    m_numDocs = _num;
  }

  public void setResultType( int _type ) {
    m_resultType = _type;
  }

  public void setQueryTerms( List _terms ) {
    m_queryTerms = _terms;
  }

//    public void setTermFrequency( String _term, int _freq ) {
//      m_frequencies.put( _term, new Integer(_freq) );
//    }

  public void setTermFrequencies( Map _freqs ) {
    m_frequencies = _freqs;
  }

  /** */

  public int getNumOfDocs() {
    return m_numDocs;
  }

  public int getResultType() {
    return m_resultType;
  }

  public List getQueryTerms() {
    return m_queryTerms;
  }
  
  public Map getTermFrequencies() {
    return m_frequencies;
  }
  
//    public int getTermFrequency( String _term ) {
//      return ((Integer)m_frequencies.get(_term)).intValue();
//    }

//    public List getDocumentIDs() {
//      NzdlQueryHit hit = null;
//      //Set docIDs = new HashSet();
//      List docIDs = new ArrayList();
//      for (ListIterator itr = m_resultSet.listIterator(); itr.hasNext(); ) {
//        hit = (NzdlQueryHit) itr.next();
//        docIDs.add( hit.getDocumentID() );
//      }
//      return docIDs;
//    }

    public List getDocumentIDs() {
      return m_docIDs;
    }

//    public Set getMetaData( String _docID, String _metaTag ) {
//      NzdlQueryHit hit = null;
//      for (ListIterator itr = m_resultSet.listIterator(); itr.hasNext(); ) {
//        hit = (NzdlQueryHit) itr.next();
//        if ( _docID.equals( hit.getDocumentID() ) ) {
//  	return hit.getMetaDataValues( _metaTag );
//        }
//      }
//      return null;
//    }

  public Set getMetaData( String _docID, String _metaTag ) {
    Map metaData = (Map) m_docToMetaDataMap.get( _docID );
    return (Set) metaData.get( _metaTag );
  }

  public Map getMetaData( String _metaTag ) {
    Map metaData = new HashMap();
    for (ListIterator itr = m_resultSet.listIterator(); itr.hasNext(); ) {
      NzdlQueryHit hit = (NzdlQueryHit) itr.next();
      metaData.put( hit.getDocumentID(), hit.getMetaDataValues(_metaTag) );
    }
    return metaData;
  }

  public Map getAllMetaData( ) {
    return m_docToMetaDataMap;
  }

}
